//
//  HeadersH2CaretLinkModel.swift
//  MVMCoreUI
//
//  Created by Lekshmi S on 01/07/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//

import Foundation
public class HeadersH2CaretLinkModel: HeaderModel, MoleculeModelProtocol, ParentMoleculeModelProtocol {
    //--------------------------------------------------
    // MARK: - Properties
    //--------------------------------------------------
    public static var identifier: String = "headerH2CrtBtn"
    public var titleLockup: TitleLockupModel
    public var caretLink: CaretLinkModel
    private var helper = DeprecatedHeadlineBodyHelper()
    
    public var children: [MoleculeModelProtocol] {
        [titleLockup, caretLink]
    }
    
    public func replaceChildMolecule(with molecule: MoleculeModelProtocol) throws -> Bool  {
        return try replaceChildMolecule(at: &titleLockup, with: molecule)
        || replaceChildMolecule(at: &caretLink, with: molecule)
    }
    
    //--------------------------------------------------
    // MARK: - Initializer
    //--------------------------------------------------
    public init(titleLockup: TitleLockupModel, caretLink: CaretLinkModel) {
        self.titleLockup = titleLockup
        self.caretLink = caretLink
        super.init()
    }
    
    //--------------------------------------------------
    // MARK: - Methods
    //--------------------------------------------------
    public override func setDefaults() {
        if topPadding == nil {
            topPadding = Padding.Component.VerticalMarginSpacing
        }
        if bottomPadding == nil {
            bottomPadding = Padding.Component.VerticalMarginSpacing
        }
        if titleLockup.title.fontStyle == nil {
            titleLockup.title.fontStyle = Styler.Font.RegularTitleXLarge
        }
        if titleLockup.subTitle?.fontStyle == nil {
            titleLockup.subTitle?.fontStyle = Styler.Font.RegularTitleMedium
        }
        super.setDefaults()
    }
    
    //--------------------------------------------------
    // MARK: - Keys
    //--------------------------------------------------
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case titleLockup
        case caretLink
    }
    
    //--------------------------------------------------
    // MARK: - Codec
    //--------------------------------------------------
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        titleLockup = try typeContainer.decodeMolecule(codingKey: .titleLockup)
        caretLink = try typeContainer.decode(CaretLinkModel.self, forKey: .caretLink)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(caretLink, forKey: .caretLink)
        guard try !helper.deprecatedEncode(to: encoder) else { return }
        try container.encode(titleLockup, forKey: .titleLockup)
    }
}
